<?php

/*
  Module developed for the Open Source Content Management System WebsiteBaker (http://websitebaker.org)
  Copyright (C) 2017, Christoph Marti

  LICENCE TERMS:
  This module is free software. You can redistribute it and/or modify it
  under the terms of the GNU General Public License - version 2 or later,
  as published by the Free Software Foundation: http://www.gnu.org/licenses/gpl.html.

  DISCLAIMER:
  This module is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.
*/

if (!\defined('SYSTEM_RUN')) {require( \dirname(\dirname(\dirname((__DIR__)))).'/config.php');}

    $sAddonPath = (dirname(__DIR__));
    $sAddonName = \basename($sAddonPath);
    $sAddonRel = '/modules/'.$sAddonName;
    $inc_path = str_replace('\\','/',dirname(__DIR__));

// Look for language file
    if (\is_readable($sAddonPath.'/languages/EN.php')) {require($sAddonPath.'/languages/EN.php');}
    if (\is_readable($sAddonPath.'/languages/'.DEFAULT_LANGUAGE.'.php')) {require($sAddonPath.'/languages/'.DEFAULT_LANGUAGE.'.php');}
    if (\is_readable($sAddonPath.'/languages/'.LANGUAGE.'.php')) {require($sAddonPath.'/languages/'.LANGUAGE.'.php');}

if (!isset($_POST['action']) || $_POST['action'] != 'update_pos' || !isset($_POST['id']) || !isset($_POST['mod_name'])) {
    $jsonrpc = \json_encode([
              'jsonrpc' => "2.0",
              'OK' => 0,
              'error' => [
                  'code' => 404,
                  'message' => \sprintf('%s "%s"', $MESSAGE['MISSING_REQUEST'], stripcslashes($sJsonString)),
                  'id' => "id"
            ]
        ],\JSON_UNESCAPED_SLASHES);
        \trigger_error(sprintf('[%d] Sanitize incoming parameters %s',__LINE__, $jsonrpc), E_USER_NOTICE);
    die($jsonrpc);
} else {

    // Get module name and config
//    require($inc_path.'/info.php');
    require($inc_path.'/convert.php');
    require($sAddonPath.'/config.php');

    // Load admin class
    $admin = new \admin('Modules', 'module_view', false, false);

    // Check if module name in file info.php and post array match
    if ($mod_name != $_POST['mod_name']) {
    $jsonrpc = \json_encode([
                  'jsonrpc' => "2.0",
                  'OK' => 0,
                  'message' => \sprintf('%s "%s"',$MESSAGE['FAILED_NAME'], $mod_name),
                  'error' => [
                      'code' => 400,
                      'id' => "id"
                ]
            ],\JSON_UNESCAPED_SLASHES);
        \trigger_error(\sprintf('%s "%s" != "%s"',$MESSAGE['FAILED_NAME'], $mod_name,$_POST['mod_name']), E_USER_NOTICE);
        die($jsonrpc);
    }

    // Check if module is registered in the database
    $addon_id = $database->get_one('SELECT `addon_id` FROM `'.TABLE_PREFIX.'addons` WHERE `type` = \'module\' AND `directory` = \''.$mod_name.'\' ');
    if (!is_numeric($addon_id)) {
        die();
    }

    // Check if user has permissions to access the module
    if (!($admin->is_authenticated() && $admin->get_permission($mod_name, 'module'))) {
        die();
    }

    // Set the new item positions depending on asc (post array) or desc (post array reverse)
    $positions = $_POST['id'];
    if (isset($order_by_position_asc) && !$order_by_position_asc) {
        $positions = array_reverse($positions);
    }
    foreach ($positions as $position => $item_id) {
        $database->query('UPDATE `'.TABLE_PREFIX.'mod_'.$mod_name.'_items` SET `position` = '.(int)$position.' + 1 WHERE `item_id` = '.(int)$item_id);
    }
}
