<?php

/*
  Module developed for the Open Source Content Management System WebsiteBaker (http://websitebaker.org)
  Copyright (C) 2017, Christoph Marti

  LICENCE TERMS:
  This module is free software. You can redistribute it and/or modify it
  under the terms of the GNU General Public License  - version 2 or later,
  as published by the Free Software Foundation: http://www.gnu.org/licenses/gpl.html.

  DISCLAIMER:
  This module is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.
*/

/**
 * upload.php
 *
 * Copyright 2013, Moxiecode Systems AB
 * Released under GPL License.
 *
 * License: http://www.plupload.com/license
 * Contributing: http://www.plupload.com/contributing
 */
if (!\defined('SYSTEM_RUN')) {require( (\dirname(\dirname(\dirname((__DIR__))))).'/config.php');}

    if (!\function_exists('media_filename')) {require (WB_PATH.'/framework/functions.php');}

    $sAddonPath = (dirname(__DIR__));
    $sAddonName = \basename($sAddonPath);
    $sAddonRel  = '/modules/'.$sAddonName;
    $inc_path   = str_replace('\\','/',dirname(__DIR__));

//    require($inc_path.'/info.php');
    require($inc_path.'/convert.php');
    require($sAddonPath.'/resize_img.php');
    require($sAddonPath.'/pngthumb.php');

// Look for language file
    if (\is_readable($sAddonPath.'/languages/EN.php')) {require($sAddonPath.'/languages/EN.php');}
    if (\is_readable($sAddonPath.'/languages/'.DEFAULT_LANGUAGE.'.php')) {require($sAddonPath.'/languages/'.DEFAULT_LANGUAGE.'.php');}
    if (\is_readable($sAddonPath.'/languages/'.LANGUAGE.'.php')) {require($sAddonPath.'/languages/'.LANGUAGE.'.php');}

// Load admin class
    $admin = new \admin('Modules', 'module_view', false, false);

    $aRequiredRequests = [
                        'name',
                        'chunk',
                        'chunks',
                        'mod_name',
                        'section_id',
                        'item_id',
                        'imgresize',
                        'maxwidth',
                        'maxheight',
                        'quality',
                    ];

    $aGetRequests = $oRequest->getParamNames();

    $aCheckRequests = \array_diff($aRequiredRequests, $aGetRequests);

    $sOneforAllLogFile = WB_PATH.'/var/log/'.$sAddonName.'.log.php';
    if (!\is_writable($sOneforAllLogFile)){
        $sLogContent  = '<?php die(\'illegal file access\'); ?>'
                      . 'created: ['.\date('r').']'.PHP_EOL;
        \file_put_contents($sOneforAllLogFile, $sLogContent);
    }
// Validate post var
    $sJsonString = \json_encode($aCheckRequests, \JSON_FORCE_OBJECT);

  if (sizeof($aCheckRequests)){
      $jsonrpc = \json_encode([
                'jsonrpc' => "2.0",
                'OK' => 0,
                'error' => [
                    'code' => 404,
                    'message' => \sprintf('%s "%s"', $MESSAGE['MISSING_REQUEST'], stripcslashes($sJsonString)),
                    'id' => "id"
              ]
          ],\JSON_UNESCAPED_SLASHES);
      \file_put_contents($sOneforAllLogFile, '['.\date('r').'] '.$jsonrpc.PHP_EOL, \FILE_APPEND);
      die($jsonrpc);
  }
// Chunking might be enabled
    $chunk      = $oRequest->getParam('chunk', FILTER_VALIDATE_BOOLEAN); // [''])  ? intval($_POST['chunk'])  : 0;
    $chunks     = $oRequest->getParam('chunk', FILTER_VALIDATE_INT); // ? intval($_POST['chunks']) : 0;
// Other vars
    $section_id = $oRequest->getParam('section_id', FILTER_VALIDATE_INT);//intval($_POST['section_id']);
    $item_id    = $oRequest->getParam('item_id', FILTER_VALIDATE_INT);//intval($_POST['item_id']);
    $imgresize  = $oRequest->getParam('imgresize', FILTER_VALIDATE_BOOLEAN);//intval($_POST['imgresize']);
    $maxheight  = $oRequest->getParam('maxwidth', FILTER_VALIDATE_INT);//intval($_POST['maxwidth']);
    $maxwidth   = $oRequest->getParam('maxheight', FILTER_VALIDATE_INT);//intval($_POST['maxheight']);
    $quality    = $oRequest->getParam('quality', FILTER_VALIDATE_INT);//intval($_POST['quality']);
    $sMatch     = $oRequest->getParam('mod_name', FILTER_SANITIZE_STRING);//$_POST['mod_name']

// SOME SECURITY CHECKS
// Check if module name in file info.php and post array match
    if ($mod_name != $sMatch) {
        $jsonrpc = \json_encode([
                  'jsonrpc' => "2.0",
                  'OK' => 0,
                  'error' => [
                      'code' => 400,
                      'message' => \sprintf('%s "%s"',$MESSAGE['FAILED_NAME'], $mod_name),
                      'id' => "id"
                ]
            ],\JSON_UNESCAPED_SLASHES);
        \file_put_contents($sOneforAllLogFile, '['.\date('r').'] '.$jsonrpc.PHP_EOL, \FILE_APPEND);
        die($jsonrpc);
    }
// Check if module is registered in the database
    if (!$database->get_one('SELECT `addon_id` FROM `'.TABLE_PREFIX.'addons` WHERE `type` = \'module\' AND `directory` = \''.$mod_name.'\' ')) {
        $jsonrpc = \json_encode([
                  'jsonrpc' => "2.0",
                  'OK' => 0,
                  'error' => [
                      'code' => 400,
                      'message' => \sprintf('"%s" %s', $mod_name, $MESSAGE['NOT_REGISTERED']),
                      'id' => "id"
                ]
            ],\JSON_UNESCAPED_SLASHES);
        \file_put_contents($sOneforAllLogFile, '['.\date('r').'] '.$jsonrpc.PHP_EOL, \FILE_APPEND);
        die($jsonrpc);
    }

// Check if user has permissions to access the module
    if (!($admin->is_authenticated() && $admin->get_permission($mod_name, 'module'))) {
        $jsonrpc = \json_encode([
                  'jsonrpc' => "2.0",
                  'OK' => 0,
                  'error' => [
                      'code' => 403,
                      'message' => sprintf('%s "%s"', $MESSAGE['ADMIN_INSUFFICIENT_PRIVELLIGES'],$mod_name),
                      'id' => "id"
                ]
            ],\JSON_UNESCAPED_SLASHES);
        \file_put_contents($sOneforAllLogFile, '['.\date('r').'] '.$jsonrpc.PHP_EOL, \FILE_APPEND);
        die($jsonrpc);
    }

// UPLOAD SETTINGS
// 5 minutes execution time
    @set_time_limit(5 * 60);

// Uncomment this one to fake upload time
// usleep(5000);

// Target directory
    $cleanup_target_dir = true;      // Remove old files
    $max_file_age       = 5 * 3600;  // Temp file age in seconds

// SEND HEADERS
// Make sure file is not cached (as it happens for example on iOS devices)
    header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
    header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT');
    header('Cache-Control: no-store, no-cache, must-revalidate');
    header('Cache-Control: post-check=0, pre-check=0', false);
    header('Pragma: no-cache');
/*
// Support CORS
header('Access-Control-Allow-Origin: *');
// other CORS headers if any...
if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {
    exit; // finish preflight CORS requests here
}
*/

// IMAGE AND THUMBNAIL
// Set array of all image and thumb directories
    $directories = array(
        '',
        '/images',
        '/thumbs',
        '/images/item'.$item_id,
        '/thumbs/item'.$item_id
    );

// Try to make the needed directories for image and thumb
#$img_section = $database->get_one("SELECT `img_section` FROM `".TABLE_PREFIX."mod_".$mod_name."_page_settings` WHERE `section_id` = '".$section_id."'");
    $sql  = 'SELECT `img_section` FROM `'.TABLE_PREFIX.'mod_'.$mod_name.'_page_settings` '
          . 'WHERE `section_id`=\' '.$section_id.'\' ';
    $img_section = $database->get_one($sql);
    if ($img_section == 0) {
        foreach ($directories as $i => $directory) {
            $directory_path = WB_PATH.MEDIA_DIRECTORY.'/'.$mod_name.$directory;
            make_dir($directory_path);
        // Save the directory pathes for later use
            if ($i == 3) $img_dir_path   = $directory_path;
            if ($i == 4) $thumb_dir_path = $directory_path;
        // Add index.php files if it is not existing yet
            if (!is_file($directory_path.'/index.php')) {
                $content = ''."<?php
    header('Location: ../index.php');
";
                $handle = fopen($directory_path.'/index.php', 'w');
                fwrite($handle, $content);
                fclose($handle);
                change_mode($directory_path.'/index.php', 'file');
            }
        }
    }

// Get a file name
if (isset($_REQUEST['name'])) {
    $file = $_REQUEST['name'];
} elseif (!empty($_FILES)) {
    $file = $_FILES['file']['name'];
} else {
    $file = uniqid('file_');
}

// Check filename
    $path_parts = pathinfo($file);
    $filename   = $path_parts['basename'];
    $fileext    = $path_parts['extension'];
    $filename   = str_replace('.'.$fileext, '', $filename);  // Filename without extension
    $filename   = str_replace(' ', '_', $filename);          // Replace spaces by underscores
    $fileext    = strtolower($fileext);

// Make sure the image is a jpg or png file
    if (!($fileext == 'jpg' || $fileext == 'jpeg' || $fileext == 'png')) {
        $jsonrpc = \json_encode([
                  'jsonrpc' => "2.0",
                  'OK' => 0,
                  'error' => [
                      'code' => 200,
                      'message' => sprintf(' %s', $MESSAGE['GENERIC_FILE_TYPES'].' .jpg, .jpeg, .png'),
                      'filename' => $filename,
                      'id' => "id"
                ]
            ],\JSON_UNESCAPED_SLASHES);
        \file_put_contents($sOneforAllLogFile, '['.\date('r').'] '.$jsonrpc.PHP_EOL, \FILE_APPEND);
        die($jsonrpc);
    }
// Check for invalid chars in filename
    if (!preg_match('#^[a-zA-Z0-9._-]*$#', $filename)) {
        $jsonrpc = \json_encode([
                  'jsonrpc' => "2.0",
                  'OK' => 0,
                  'error' => [
                      'code' => 403,
                      'message' => sprintf('%s', $MOD_ONEFORALL[$mod_name]['ERR_INVALID_FILE_NAME']),
                      'filename' => $filename,
                      'id' => "id"
                ]
            ],\JSON_UNESCAPED_SLASHES);
        \file_put_contents($sOneforAllLogFile, '['.\date('r').'] '.$jsonrpc.PHP_EOL, \FILE_APPEND);
        die($jsonrpc);
    }

// Path to the new image
    $img_path = $img_dir_path.'/'.$filename.'.'.$fileext;

// Check if filename already exists
    if (file_exists($img_path)) {
        $jsonrpc = \json_encode([
                  'jsonrpc' => "2.0",
                  'OK' => 0,
                  'error' => [
                      'code' => 202,
                      'message' => sprintf('[%d] %s',__LINE__, $MESSAGE['MEDIA_FILE_EXISTS']),
                      'filename' => $filename,
                      'id' => "id"
                ]
            ],\JSON_UNESCAPED_SLASHES);
        \file_put_contents($sOneforAllLogFile, '['.\date('r').'] '.$jsonrpc.PHP_EOL, \FILE_APPEND);
        die($jsonrpc);
    }


// Remove old temp files
    if ($cleanup_target_dir) {
        if (!is_dir($img_dir_path) || !$dir = opendir($img_dir_path)) {
            $jsonrpc = \json_encode([
                      'jsonrpc' => "2.0",
                      'OK' => 0,
                      'error' => [
                          'code' => 100,
                          'message' => sprintf('%s "%s"',$MESSAGE['FAILED_TEMPDIR'], basename($img_dir_path)),
                          'filename' => basename($img_dir_path),
                          'id' => "id"
                    ]
                ],\JSON_UNESCAPED_SLASHES);
            \file_put_contents($sOneforAllLogFile, '['.\date('r').'] '.$jsonrpc.PHP_EOL, \FILE_APPEND);
            die($jsonrpc);
        }
        while (($file = readdir($dir)) !== false) {
            $tmp_file_path = $img_dir_path.'/'.$file;
            // If temp file is current file proceed to the next
            if ($tmp_file_path == "{$img_path}.part") {
                continue;
            }
            // Remove temp file if it is older than the max age and is not the current file
            if (preg_match('/\.part$/', $file) && (filemtime($tmp_file_path) < time() - $max_file_age)) {
                @unlink($tmp_file_path);
            }
        }
        closedir($dir);
    }
// Open temp file
    if (!$out = @fopen("{$img_path}.part", $chunks ? 'ab' : 'wb')) {
        $jsonrpc = \json_encode([
                  'jsonrpc' => "2.0",
                  'OK' => 0,
                  'error' => [
                      'code' => 102,
                      'message' => sprintf('%s', $MESSAGE['FAILED_OUTPUT_STREAM']),
                      'id' => "id"
                ]
            ],\JSON_UNESCAPED_SLASHES);
        \file_put_contents($sOneforAllLogFile, '['.\date('r').'] '.$jsonrpc.PHP_EOL, \FILE_APPEND);
        die($jsonrpc);
    }

    if (!empty($_FILES)) {
        if ($_FILES['file']['error'] || !is_uploaded_file($_FILES['file']['tmp_name'])) {
            $jsonrpc = \json_encode([
                      'jsonrpc' => "2.0",
                      'OK' => 0,
                      'error' => [
                          'code' => 103,
                          'message' => sprintf('%s', $MESSAGE['FAILED_MOVE_UPLOADFILE']),
                          'id' => "id"
                    ]
                ],\JSON_UNESCAPED_SLASHES);
            \file_put_contents($sOneforAllLogFile, '['.\date('r').'] '.$jsonrpc.PHP_EOL, \FILE_APPEND);
            die($jsonrpc);
        }

        // Read binary input stream and append it to temp file
        if (!$in = @fopen($_FILES['file']['tmp_name'], 'rb')) {
            $jsonrpc = \json_encode([
                      'jsonrpc' => "2.0",
                      'OK' => 0,
                      'error' => [
                          'code' => 101,
                          'message' => sprintf('%s',$MESSAGE['FAILED_INPUT_STREAM']),
                          'id' => "id"
                    ]
                ],\JSON_UNESCAPED_SLASHES);
            \file_put_contents($sOneforAllLogFile, '['.\date('r').'] '.$jsonrpc.PHP_EOL, \FILE_APPEND);
            die($jsonrpc);
        }
    } else {
        if (!$in = @fopen('php://input', 'rb')) {
            $jsonrpc = \json_encode([
                      'jsonrpc' => "2.0",
                      'OK' => 0,
                      'error' => [
                          'code' => 101,
                          'message' => sprintf('%s',$MESSAGE['FAILED_INPUT_STREAM']),
                          'id' => "id"
                    ]
                ],\JSON_UNESCAPED_SLASHES);
            \file_put_contents($sOneforAllLogFile, '['.\date('r').'] '.$jsonrpc.PHP_EOL, \FILE_APPEND);
            die($jsonrpc);
        }
    }

    while ($buff = fread($in, 4096)) {
        fwrite($out, $buff);
    }

    @fclose($out);
    @fclose($in);

// Check if file has been uploaded
    if (!$chunks || $chunk == $chunks - 1) {
        // Strip the temp .part suffix off
        rename("{$img_path}.part", $img_path);
    }

// If we have to load other chunks, stop here and return success response
    if ($chunks && $chunk < $chunks - 1) {
        $jsonrpc = \json_encode([
                  'jsonrpc' => "2.0",
                  'result' => null,
                  'id' => "id",
                  'OK' => 1,
                  'success' => [
                      'code' => 200,
                ]
            ],\JSON_UNESCAPED_SLASHES);
//        \file_put_contents($sOneforAllLogFile, '['.\date('r').'] '.$jsonrpc.PHP_EOL, \FILE_APPEND);
        die($jsonrpc);
    }

// CREATE A THUMB

// Get thumb size for this page
    $iResize = $database->get_one('SELECT `resize` FROM `'.TABLE_PREFIX.'mod_'.$mod_name.'_page_settings` WHERE `section_id` = '.$section_id.' ');
    if ($iResize > 0) {
        // Thumbnail path
        $thumb_path = $thumb_dir_path.'/'.$filename.'.'.$fileext;
        // Check thumbnail type
        if ($fileext == 'png') {
            make_thumb_png($img_path, $thumb_path, $iResize);
        } else {
            resizeJPEG($img_path, $thumb_path, $iResize, $iResize, '90');
        }
        change_mode($thumb_path);
    }

// RESIZE IMAGE

// Check if we need to resize the image
    if ($imgresize && file_exists($img_path)) {
        // Check image type
        if ($fileext == 'png') {
            resizePNG($img_path, $img_path, $maxwidth, $maxheight);
        } else {
            resizeJPEG($img_path, $img_path, $maxwidth, $maxheight, $quality);
        }
        change_mode($img_path);
    }

// ADD IMAGE TO THE DATABASE

// Get image top position for this item
    $top_position = $database->get_one('SELECT MAX(`position`) AS `top_position` FROM `'.TABLE_PREFIX.'mod_'.$mod_name.'_images` WHERE `item_id` = '.$item_id.' ');
// Increment position (db function returns NULL if this item has no image yet)
    $top_position = intval($top_position) + 1;

// Insert filename into database
    $filename = $filename.'.'.$fileext;
    $Sql =  'INSERT INTO `'.TABLE_PREFIX.'mod_'.$mod_name.'_images` SET '
                       .  '`item_id`= '.(int)$item_id.' , '
                       .  '`filename`= \''.$database->escapeString($filename).'\', '
                       .  '`active`= 1, '
                       .  '`position`= '.(int)$top_position.', '
                       .  '`caption` = \'\' ';
    $database->query($Sql);
// Get new image id
    $img_id = 'undefined';
    $img_id = $database->getLastInsertId();

// Check if there was a db error
    if ($database->is_error()) {
        $jsonrpc = \json_encode([
                  'jsonrpc' => "2.0",
                  'OK' => 0,
                  'error' => [
                      'code' => 202,
                      'message' => sprintf('Database error: %s', $database->get_error()),
                      'id' => "id"
                ]
            ],\JSON_UNESCAPED_SLASHES);
        \file_put_contents($sOneforAllLogFile, '['.\date('r').'] '.$jsonrpc.PHP_EOL, \FILE_APPEND);
        die($jsonrpc);
    }

// SERVER RESPONSE
// Return Success JSON-RPC response
        $jsonrpc = \json_encode([
                  'jsonrpc' => "2.0",
                  'result' => null,
                  'id' => "id",
                  'img_id'  => $img_id,
                  'filename' => $filename,
                  'OK' => 1,
                  'success' => [
                      'code' => 200,
                ]
            ],\JSON_UNESCAPED_SLASHES);
//        \file_put_contents($sOneforAllLogFile, '['.\date('r').'] '.$jsonrpc.PHP_EOL, \FILE_APPEND);
        die($jsonrpc);

//die('{"jsonrpc" : "2.0", "result" : null, "id" : "id", "img_id" : "'.$img_id.'", "filename" : "'.$filename.'"}');
