/*
 Javascript routines for WebsiteBaker module OneForAll
 Copyright (C) 2017, Christoph Marti

 This Javascript routines are free software. You can redistribute it and/or modify it
 under the terms of the GNU General Public License - version 2 or later,
 as published by the Free Software Foundation: http://www.gnu.org/licenses/gpl.html.

 The Javascript routines are distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 GNU General Public License for more details.
    var $ = jQuery.noConflict();
document.addEventListener('DOMContentLoaded', (function(event){
 */

$(document).ready(function() {

    if (typeof oneforall !== "undefined"){
      var jsonobj = oneforall;

      let folder = document.getElementById('AddonFolder');
    //console.log(jsonobj);

      if (folder) {
          var AddonFolder = folder.innerHTML;
          var AddonUrl  = WB_URL+'/modules/'+AddonFolder;
          var Folder = AddonUrl.replace( WB_URL+'/modules/', '');
//console.log(AddonUrl);
      } else {
    //    var AddonUrl = WB_URL+'/modules/';
          var AddonUrl  = this.baseURI.replace(/\\/g, '').replace(/\/[^\/]*\/?$/, '');
          var ModuleUrl = AddonUrl.replace(/\/[^\/]*\/*$/g, '/');
          var AddonFolder = AddonUrl.replace( ModuleUrl, '');
      }
    //console.log(ModuleUrl);

      if (AddonFolder!=="page"){
      //console.log(AddonUrl);
      //console.log(Folder);
      } else {
        alert("Insert a hidden div container with id=AddonFolder")
      }
    // **********************************************************************************
    //   OneForAll AJAX MESSAGE
    //   Function to show a message if an ajax request has been successful
    // **********************************************************************************
      function addMessageBlock(bNew){
    //console.log(typeof bNew);
      // Add the message div if not existing yet
          if (typeof bNew === 'undefined' && document.getElementById('success_msg_b') === null) {
              $('body').prepend('<div id="success_msg_b" class="animated bounceInDown" style="display: none;">&#160;</div>');
          } else {
              $('body').prepend('<div id="success_msg_b" class="animated bounceInDown" style="display: none;">&#160;</div>');
          }
      }
      var success_msg = $('#success_msg_b');
      addMessageBlock();
    //console.log(success_msg.txt());
      // Ajax success message
      var loading = success_msg.hide();
      $(document)
              .ajaxStart(function () {
                  loading.show();
              })
              .ajaxStop(function (e) {
                  loading.show();
    //                success_msg.text(mod_'+jsonobj.AddonName+'.txt_toggle_message);
                  setTimeout(function () {
                      loading.hide();
    //console.log(loading);
                  }, 6000);
              });

    // **********************************************************************************
    //   OneForAll SORTABLE ITEMS TABLE
    //   Function to enable/disable an item
    // **********************************************************************************
    //console.log('mod_'+jsonobj.AddonName);
    //console.log(AddonUrl);

      $('[class^="mod_'+jsonobj.AddonName+'_active"]').click(function () {

          // Get current active button class
          var button = $(this);
          var current_class = button.prop('class');
          // Check if item is enabled/disabled
          if (current_class == 'mod_'+jsonobj.AddonName+'_active0_b') {
              var bt_value = 1;
              var bt_title = "mod_"+jsonobj.AddonName+".txt_disable";
          } else {
              var bt_value = 0;
              var bt_title = "mod_"+jsonobj.AddonName+".txt_enable";
          }

          // Get the item_id
          var item_id = button.closest('tr').prop('id').replace('id_', '');

          // Post active to the server  AddonUrl
    //console.log(AddonUrl + '/ajax/toggle_active.php');
          jQuery.post(AddonUrl + '/ajax/toggle_active.php',
    //        jQuery.post(WB_URL+'/modules/' + mod_oneforall.mod_name + '/ajax/toggle_active.php',
                  {
                      value: bt_value,
                      item_id: item_id,
                      mod_name: AddonFolder,
                      action: 'update_active'
                  },
                  function () {
                      // On success remove current class and set new class, change title text
                      button.removeClass().addClass('mod_'+jsonobj.AddonName+'_active' + bt_value + '_b');
                      button.prop('title', bt_title);
                      // Set the success message used by ajaxStop(), see on top of this file
                      success_msg.text(mod_oneforall.txt_toggle_message);

                  });
      });

    // **********************************************************************************
    //   OneForAll SORTABLE ITEMS TABLE
    //   Function to sort items by drag&drop
    // **********************************************************************************
       var sort = $("#mod_oneforall_items_b");
      // Check if sortable is available
      if ($("#mod_oneforall_items_b").sortable) {

          // Fix the width of the cells so they do not collapse on drag&drop
          $('td, th', '#mod_'+jsonobj.AddonName+'_items_b').each(function () {
              var cell = $(this);
              cell.width(cell.width());
          });

          // Remove the up/down icons
          $("a[href*='move_up.php'], a[href*='move_down.php']", '#mod_'+jsonobj.AddonName+'_items_b').hide(); //

    //console.log($('#mod_'+jsonobj.AddonName+'_items_b'));
          // Make table sortable
          $('#mod_'+jsonobj.AddonName+'_items_b tbody').sortable({
              opacity: 0.8,
              update: function () {
                  var order = $(this).sortable('serialize')+'&action=update_pos&mod_name='+mod_oneforall.mod_name;
    //                var order = $(this).sortable('serialize')+'&action=update_pos&mod_name='+'mod_'+jsonobj.AddonName+'.mod_name';
                  // Post ordering to the server
                  $.post(AddonUrl+'/ajax/move_item.php',order,function () {
                      // Set the success message used by ajaxStop(), see on top of this file
                      success_msg.text(mod_oneforall.txt_dragdrop_message);
                  });
              }
          });
      }

    // **********************************************************************************
    //   OneForAll MODIFY ITEM
    //   Function to sort images by drag&drop
    // **********************************************************************************

      // Check if sortable is available
      if ($().sortable) {

          // Fix the width of the cells so they do not collapse on drag&drop
          $('td, th', '#mod_'+jsonobj.AddonName+'_images_b').each(function () {
              var cell = $(this);
              cell.width(cell.width());
          });

          // Remove the up/down icons
          $("a[href*='move_img_up.php'],a[href*='move_img_down.php']",'#mod_'+jsonobj.AddonName+'_images_b').hide();
          $('#mod_'+jsonobj.AddonName+'_images_b th:eq(4)').text('');

          // Make table sortable
          $('#mod_'+jsonobj.AddonName+'_images_b tbody').sortable({
              opacity: 0.8,
              items: "[id^='id_']",
              update: function () {
                  var order = $(this).sortable('serialize')+'&action=update_pos&mod_name='+mod_oneforall.mod_name;
                  // Post ordering to the server
                  jQuery.post(AddonUrl+'/ajax/move_image.php',order,function () {
                      // On success move 'main image' note to the top image
                      var txt_main_img = $('b, b + br', '#mod_'+jsonobj.AddonName+'_images_b');
                      $('#mod_'+jsonobj.AddonName+'_images_b tr:eq(1) td:eq(1)').prepend(txt_main_img);

                      // Set the success message used by ajaxStop(), see on top of this file
                      success_msg.text(mod_oneforall.txt_dragdrop_message);
                  });
              }
          });
      }

    // **********************************************************************************
    //   OneForAll MODIFY ITEM
    //   Function to sinc selected file with file link or preview thumb
    // **********************************************************************************

      $('#mod_'+jsonobj.AddonName+'_modify_item_b').change(function () {

          // Hide all images and links ...
          $('a.media_img, a.media_link').addClass('hidden');

          $('select.media').each(function () {
              // Get url (from select option)
              var url = $(this).val();
              // ...then display the selected one
              if (url) {
                  $(this).nextAll("a[href$='"+url+"']").removeClass('hidden');
              }
          });
      });

    // **********************************************************************************
    //   OneForAll MODIFY FIELDS
    //   Function to sort fields by drag&drop
    // **********************************************************************************

      // Check if sortable is available
      if ($().sortable) {

          // Fix the width of the cells so they do not collapse on drag&drop
          $('td, th', '#mod_'+jsonobj.AddonName+'_custom_fields_b').each(function () {
              var cell = $(this);
              cell.width(cell.width());
          });

          // Make table sortable
          $('#mod_'+jsonobj.AddonName+'_custom_fields_b > tbody').sortable({
              opacity: 0.8,
              update: function () {
                  var order = $(this).sortable('serialize')+'&action=update_pos&mod_name='+mod_oneforall.mod_name;
                  // Post ordering to the server   WB_URL+'/modules/'+mod_oneforall.mod_name
                  jQuery.post(AddonUrl+'/ajax/move_field.php',order,function () {
                      // Set the success message used by ajaxStop(), see on top of this file
                      success_msg.text(mod_oneforall.txt_dragdrop_message);
                  });
              }
          });
      }

    // **********************************************************************************
    //   OneForAll MODIFY FIELDS
    //   Function to sinc form with selected field type
    // **********************************************************************************
      function decodeHtml(str)
      {
          var map =
          {
              '&amp;': '&',
              '&lt;': '<',
              '&gt;': '>',
              '&quot;': '"',
              '&#039;': "'"
          };
          return str.replace(/&amp;|&lt;|&gt;|&quot;|&#039;/g, function(m) {return map[m];});
      }

      $('#mod_'+jsonobj.AddonName+'_custom_fields_b select').change(function () {
          // Get type (from select option)
          var type = $(this).val();
          // Get the elements
          var textarea = $(this).closest('tr').nextAll().eq(1).find('textarea'),
              extra_label = $(this).closest('tbody').prev().find('th:last'),
              extra_field = $(this).parent().nextAll().eq(2).find('input');

          // First hide all labels and fields ...
          extra_label.find('span').addClass('mod_'+jsonobj.AddonName+'_hidden_extra_label_b');
          extra_field.addClass('mod_'+jsonobj.AddonName+'_hidden_extra_field_b');
    //console.log(extra_label);
          // ...then display it if the type matches
          var types = [
            ''+jsonobj.AddonName+'_link',
            'foldergallery_link',
            'media',
            'upload',
            'select',
            'multiselect',
            'checkbox',
            'switch',
            'radio',
            'group'
          ];
          var tl = types.length;
          for (i = 0; i < tl; i++) {
              if (type == types[i]) {
                  child = i + 1;
                  extra_label.find(':nth-child(' + child + ')').removeClass('mod_'+jsonobj.AddonName+'_hidden_extra_label_b');
                  extra_field.removeClass('mod_'+jsonobj.AddonName+'_hidden_extra_field_b');
              }
          }
          // If sync is activated, get default template (html) and insert it into the textarea
          if ($('#sync_type_template').prop('checked')) {
              var childArea    = $("#mod_"+jsonobj.AddonName+"_default_templates_b [class$='_"+type+"_f']"),
                  default_html = childArea.parent().html();
              if (default_html !== undefined) {
    //console.log(childArea.html());
    //console.log(default_html.trim());
    //                textarea.val = default_html.trim();
                  textarea.val(default_html.trim()).addClass('highlight').show();
                  // Delay until css animation has finished
                  setTimeout(function () {
                      textarea.removeClass('highlight');
                  }, 1050);
              }
          }
      });
    /* */


    // var JsPanelJs   = WB_URL+"/include/plugins/default/jspanel/4.2.1/dist/jspanel.js";
    //var FolderObj = json_decode(Folder);

    let helpModal = document.getElementById('help-started');
      if (helpModal){
    //console.log(helpModal);
        helpModal.addEventListener("click", function() {
    //          modalFrame.style.display = "block";
    /*
          var JsPanelCss = WB_URL+"/include/plugins/default/jspanel/4.2.1/dist/jspanel.css";
          if (typeof LoadOnFly!=='function' || typeof LoadOnFly==='undefined' || !LoadOnFly){
              $.insert(JsPanelCss);
    //            $.insert(JsPanelJs);
          } else {
              LoadOnFly("head", JsPanelCss);
    //            LoadOnFly('head', JsPanelJs);
          }
    */
      if (typeof jsPanel!=="undefined"){};
          var ftbHelp = [
            '<div class="info-modal-footer">',
              '<button id="closeModalBox" class="btn btn-default" type="button" data-dismiss="modal" >Close<\/button>',
            '<\/div>'
          ];
          var helpConfig = {
              id : "helppanel-1",
              theme: "steelblue", // #215a7a
    //            id: function(){return "helppanel";},
              animateIn: "w3-animate-opacity",
    //          animateOut: "jsPanelFadeOut",
              contentOverflow: "scroll",
              closeOnEscape: true,
              headerLogo:   THEME_URL+"/images/apple-touch-icon.png",
              headerTitle:  "WebsiteBaker OneForAll Help",
              position:     "center",
              border:       "1px solid",
              header:       true,
              paneltype : "helppanel",
              panelSize: {
                  width: function() {
                      return window.innerWidth/2;
                  },
                  height: function() {
                      return window.innerHeight/1.5;
                  }
              },
              footerToolbar: ftbHelp,
              callback: function (panel) {
                  // handlers for the toolbar items like:
                  jsPanel.pointerup.forEach(function (evt) {
                      panel.footer.querySelector('#closeModalBox').addEventListener(evt, function () {
                      panel.close();
                      });
                  });
              },
              contentAjax: {
                  url: AddonUrl+"/help.php",
                  method: "POST",
                  data: "page_id="+jsonobj.page_id,
                  done: function (panel) {
                      contentSize:  '150% 1%',
                      panel.content.innerHTML = this.responseText;
                      panel.querySelector('.jsPanel-btn-close').addEventListener('click', function () {
                        panel.close();
                      });
                  },
                  beforeSend: function() {
                      this.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
                  }
              }
          }; //  end hintConfig

          jsPanel.create({
              config: helpConfig
          });

        }); // end dhelp-started

      }; // end helpModal
    }

/* not needed in moment, should be enabled by settings
    // Handle the case when form was submitted before uploading has finished
    $('#modify').submit(function(e) {
        // Files in queue upload them first
        if ($('#uploader').plupload('getFiles').length > 0) {
            // When all files are uploaded submit form
            $('#uploader').on('complete', function() {
                $('#modify')[0].submit();
            });
            $('#uploader').plupload('start');
        } else {
            alert("You must have at least one file in the queue.");
        }
        return false; // Keep the form from submitting
    });
*/
});

// **********************************************************************************
//   OneForAll MODIFY FIELDS
//   Function to confirm that a field and all associated data will be deleted
// **********************************************************************************

    function confirm_delete(message, txt_field) {
        var fields = '';
        $('select[name^="fields"]').each(function (index) {
            var type = $(this).val();
            var id = $(this).prop('name').replace(/[^0-9\.]/g, '');
            if (type === 'delete') {
                index++;
                fields += "\n   • " + txt_field + ' id ' + id;
            };
        });
        if (fields != '') {
            return confirm(message + fields);
        }
    };

