<?php

/*
  Module developed for the Open Source Content Management System WebsiteBaker (http://websitebaker.org)
  Copyright (C) 2017, Christoph Marti

  LICENCE TERMS:
  This module is free software. You can redistribute it and/or modify it
  under the terms of the GNU General Public License  - version 2 or later,
  as published by the Free Software Foundation: http://www.gnu.org/licenses/gpl.html.

  DISCLAIMER:
  This module is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.
*/

if (!\defined('SYSTEM_RUN')) {header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 File not found'; flush(); exit;}

try {

// Include path
    $inc_path = str_replace('\\','/',__DIR__);
// Include module info to get module name
//    require($inc_path.'/info.php');
    require($inc_path.'/convert.php');

    $sAddonBackUrl = ADMIN_URL.'/modules/index.php?advanced=1';
// Check module name for not allowed characters
    if (!preg_match('/^[a-zA-Z0-9_ \-]{3,20}$/', $module_name)) {
        $sMessage = 'Allowed characters for the module name are a-z, A-Z, 0-9, _ - (underscore) (hyphen).<br>Min 3, max 20 characters.';
        throw new \Exception (sprintf($sMessage));
    }

// Check if there is not yet a media directory using the module name
    if (is_dir(WB_URL.MEDIA_DIRECTORY.'/'.$module_name)) {
        $sMessage = 'A media directory with the name "%s" is already in use.';
        throw new \Exception (sprintf($sMessage,$module_name));
    }

// Old and new directory pathes
    $old_dir = $inc_path;
    $new_dir = dirname($inc_path).'/'.$module_directory;
// Rename module directory only when manual installation
    $action = (isset($action) ? $action : 'install');
    if (!in_array($action,['install'])) {
        // Check if the name of the module directory does not exist yet
        if ($old_dir != $new_dir && is_dir($new_dir)) {
        $sMessage = 'A module directory with the name "%s" is already in use.';
        throw new \Exception (sprintf($sMessage,$module_name));
        }

    // Rename directory
        if (!rename($old_dir, $new_dir)) {
            $sMessage = $MESSAGE['MEDIA_CANNOT_RENAME'];
            throw new \Exception (sprintf($sMessage));
        }

    } // action == install

// If module has been renamed some files have to be converted
    if ($mod_name != 'oneforall') {

        $needle  = ['oneforall','OneForAll','mod_oneforall'];
        $replace = [$mod_name,\ucwords($mod_name,'_'),'mod_'.$mod_name];

        // Convert the frontend stylesheet to the new module name
        $search_file   = 'frontend.css';
        $file_path     = $new_dir.'/'.$search_file;
        $file_contents = file_get_contents($file_path);
        $file_contents = str_replace($needle, $replace, $file_contents, $count);
        // Write replaced string back to file
        if (file_put_contents($file_path, $file_contents) === false) {
            $sMessage = '';
            throw new \Exception (sprintf(''));
            $admin->print_error('<p style="font-weight: bold;">Failed to modify the frontend stylesheet <code>'.$search_file.'</code>.</p><p>Please modify it manually by replacing the placeholders <code>'.$needle.'</code> by the new module name &quot;mod_'.$mod_name.'&quot;.</p>', ADMIN_URL.'/modules/index.php?advanced=1');
        }
        unset($file_contents);

        // Convert the backend stylesheet to the new module name
        $search_file   = 'backend.css';
    //    $needle        = 'mod_oneforall';
        $file_path     = $new_dir.'/'.$search_file;
        $file_contents = file_get_contents($file_path);
        $file_contents = str_replace($needle, $replace, $file_contents, $count);
        // Write replaced string back to file
        if (file_put_contents($file_path, $file_contents) === false) {
            $sMessage = 'Failed to modify the backend stylesheet <code>%s</code>.<br/>Please modify it manually by replacing the placeholders <code>%s</code> by the new module name "mod_%s" ';
            throw new \Exception (sprintf('$sMessage',$search_file, $needle,$mod_name));
        }
        unset($file_contents);

        // Convert the backend_body javascript file to the new module name
        $search_file   = 'backend_body.js';
        $file_path     = $new_dir.'/'.$search_file;
        $file_contents = file_get_contents($file_path);
        $file_contents = str_replace($needle, $replace, $file_contents, $count);
        // Write replaced string back to file
        if (file_put_contents($file_path, $file_contents) === false) {
            $sMessage = 'Failed to modify the backend_body javascript file <code>%s</code>.</p><p>Please modify it manually by replacing the placeholders <code>%s</code> by the new module name "mod_%s" ';
            throw new \Exception (sprintf($sMessage,$search_file, $needle,$mod_name));
        }
        unset($file_contents);

        // Convert the search file to the new module name
        $search_file   = 'search.php';
        $file_path     = $new_dir.'/'.$search_file;
        $file_contents = file_get_contents($file_path);
        $file_contents = str_replace($needle, $replace, $file_contents, $count);
        // Write replaced string back to file
        if (file_put_contents($file_path, $file_contents) === false) {
            $sMessage = 'Failed to modify the search file <code>%s</code>.</p><p>Please modify it manually by replacing the placeholders <code>%s</code> by the new module name "mod_%s" ';
            throw new \Exception (sprintf($sMessage,$search_file, $needle,$mod_name));
        }
        unset($file_contents);

        // Convert the WBReorg file to the new module name
        $search_file   = 'WBReorg.php';
        $file_path     = $new_dir.'/'.$search_file;
        $file_contents = file_get_contents($file_path);
        $file_contents = str_replace($needle, $replace, $file_contents, $count);
        // Write replaced string back to file
        if (file_put_contents($file_path, $file_contents) === false) {
            $sMessage = 'Failed to modify the WBReorg file <code>%s</code>.</p><p>Please modify it manually by replacing the placeholders <code>%s</code> by the new module name "mod_%s" ';
            throw new \Exception (sprintf($sMessage,$search_file, $needle,$mod_name));
        }
        unset($file_contents);

    }


// Create module database tables

    $database->query('DROP TABLE IF EXISTS `'.TABLE_PREFIX.'mod_'.$mod_name.'_fields`');
    $MOD_ONEFORALL[$mod_name] = 'CREATE TABLE `'.TABLE_PREFIX.'mod_'.$mod_name.'_fields` ( '
            . '`field_id` INT(11) NOT NULL AUTO_INCREMENT,'
            . '`section_id` INT(11) NOT NULL DEFAULT \'0\','
            . '`position` INT(11) NOT NULL DEFAULT \'0\','
            . '`type` VARCHAR(50) NOT NULL DEFAULT \'\','
            . '`extra` TEXT NOT NULL,'
            . '`name` VARCHAR(50) NOT NULL DEFAULT \'\','
            . '`label` VARCHAR(50) NOT NULL DEFAULT \'\','
            . '`template` TEXT NOT NULL,'
            . 'PRIMARY KEY (`field_id`),'
            . 'UNIQUE KEY `NAME` (`name`)'
            . ' )';
    $database->query($MOD_ONEFORALL[$mod_name]);

    $database->query('DROP TABLE IF EXISTS `'.TABLE_PREFIX.'mod_'.$mod_name.'_images`');
    $MOD_ONEFORALL[$mod_name] = 'CREATE TABLE `'.TABLE_PREFIX.'mod_'.$mod_name.'_images` ( '
            . '`img_id` INT(11) NOT NULL AUTO_INCREMENT, '
            . '`item_id` INT(11) NOT NULL DEFAULT \'0\','
            . '`filename` VARCHAR(150) NOT NULL DEFAULT \'\', '
            . '`active` ENUM(\'1\',\'0\') NOT NULL DEFAULT \'1\', '
            . '`position` INT(11) NOT NULL DEFAULT \'0\', '
            . '`alt` VARCHAR(255) NOT NULL DEFAULT \'\', '
            . '`title` VARCHAR(255) NOT NULL DEFAULT \'\', '
            . '`caption` TEXT NOT NULL,'
            . 'PRIMARY KEY (`img_id`)'
            . ' )';
    $database->query($MOD_ONEFORALL[$mod_name]);

    $database->query('DROP TABLE IF EXISTS `'.TABLE_PREFIX.'mod_'.$mod_name.'_items`');
    $MOD_ONEFORALL[$mod_name] = 'CREATE TABLE `'.TABLE_PREFIX.'mod_'.$mod_name.'_items` ( '
            . '`item_id` INT(11) NOT NULL AUTO_INCREMENT, '
            . '`section_id` INT(11) NOT NULL DEFAULT \'0\', '
            . '`page_id` INT(11) NOT NULL DEFAULT \'0\', '
            . '`group_id` INT(11) NOT NULL DEFAULT \'0\', '
            . '`active` INT(11) NOT NULL DEFAULT \'0\', '
            . '`featured` INT(11) NOT NULL DEFAULT \'0\', '
            . '`featured_pos` INT(11) NOT NULL DEFAULT \'0\', '
            . '`scheduling` VARCHAR(255) NOT NULL DEFAULT \'\', '
            . '`position` INT(11) NOT NULL DEFAULT \'0\', '
            . '`title` VARCHAR(255) NOT NULL DEFAULT \'\', '
            . '`link` TEXT NOT NULL, '
            . '`description` TEXT NOT NULL, '
            . '`main_image` VARCHAR(50) NOT NULL DEFAULT \'\', '
            . '`modified_when` INT(11) NOT NULL DEFAULT \'0\', '
            . '`modified_by` INT(11) NOT NULL DEFAULT \'0\', '
            . 'PRIMARY KEY (`item_id`)'
            . ' )';
    $database->query($MOD_ONEFORALL[$mod_name]);

    $database->query('DROP TABLE IF EXISTS `'.TABLE_PREFIX.'mod_'.$mod_name.'_item_fields`');
    $MOD_ONEFORALL[$mod_name] = 'CREATE TABLE `'.TABLE_PREFIX.'mod_'.$mod_name.'_item_fields` ( '
            . '`item_id` INT(11) NOT NULL DEFAULT \'0\', '
            . '`field_id` INT(11) NOT NULL DEFAULT \'0\', '
            . '`value` TEXT NOT NULL, '
            . 'UNIQUE KEY `FIELD` (`item_id`,`field_id`)'
            . ' )';
    $database->query($MOD_ONEFORALL[$mod_name]);

    $database->query('DROP TABLE IF EXISTS `'.TABLE_PREFIX.'mod_'.$mod_name.'_page_settings`');
    $MOD_ONEFORALL[$mod_name] = 'CREATE TABLE `'.TABLE_PREFIX.'mod_'.$mod_name.'_page_settings` ( '
            . '`section_id` INT(11) NOT NULL DEFAULT \'0\', '
            . '`page_id` INT(11) NOT NULL DEFAULT \'0\', '
            . '`header` TEXT NOT NULL, '
            . '`item_loop` TEXT NOT NULL, '
            . '`footer` TEXT NOT NULL, '
            . '`item_header` TEXT NOT NULL, '
            . '`item_footer` TEXT NOT NULL, '
            . '`items_per_page` INT(11) NOT NULL DEFAULT \'0\', '
            . '`resize` INT(11) NOT NULL DEFAULT \'100\', '
            . '`lightbox2` VARCHAR(10) NOT NULL DEFAULT \'detail\', '
            . '`img_section` enum(\'0\',\'1\') NOT NULL DEFAULT \'0\', '
            . 'PRIMARY KEY (`section_id`)'
            . ' )';
    $database->query($MOD_ONEFORALL[$mod_name]);
// Update db addons table
/*
// Delete not existing module oneforall from database
if (!is_dir(WB_PATH.'/modules/oneforall')) {
    $sql = 'DELETE FROM `'.TABLE_PREFIX.'addons` WHERE `type` = \'module\' and `directory` = \'oneforall\' ';
    $database->query($sql);
}
*/
// Include WB functions...
if (!function_exists('make_dir')){require(WB_PATH.'/framework/functions.php');}
// then load the renamed module into the addons table
load_module(WB_PATH.'/modules/'.$mod_name);

} catch (\Exception $ex) {

   if (!function_exists ('xnl2br')) {require(WB_PATH . '/framework/functions.php');}
    $sErrMsg = xnl2br(\sprintf('[%d] %s', $ex->getLine(), $ex->getMessage()));
    $admin->print_error ($sErrMsg, $sAddonBackUrl);
    exit;
}