<?php

/*
  Module developed for the Open Source Content Management System WebsiteBaker (http://websitebaker.org)
  Copyright (C) 2017, Christoph Marti

  LICENCE TERMS:
  This module is free software. You can redistribute it and/or modify it
  under the terms of the GNU General Public License - version 2 or later,
  as published by the Free Software Foundation: http://www.gnu.org/licenses/gpl.html.

  DISCLAIMER:
  This module is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.
*/


if (!defined('SYSTEM_RUN')) {require( (dirname(dirname((__DIR__)))).'/config.php');}

    $admin_header=true;
    // Workout if the developer wants to show the info banner
    $print_info_banner = true; // true/false
    // Tells script to update when this page was last updated
    $update_when_modified = false;
// Include WB admin wrapper script
require(WB_PATH.'/modules/admin.php');

// Include path
$inc_path = str_replace('\\','/',__DIR__);
// Get module name and config
//    require($inc_path.'/info.php');
    require($inc_path.'/convert.php');
    require($inc_path.'/config.php');

// Look for language File
if (is_readable(__DIR__.'/languages/EN.php')) {require(__DIR__.'/languages/EN.php');}
if (is_readable(__DIR__.'/languages/'.DEFAULT_LANGUAGE.'.php')) {require(__DIR__.'/languages/'.DEFAULT_LANGUAGE.'.php');}
if (is_readable(__DIR__.'/languages/'.LANGUAGE.'.php')) {require(__DIR__.'/languages/'.LANGUAGE.'.php');}

// Get header and footer
$query_page_settings = $database->query('SELECT * FROM `'.TABLE_PREFIX.'mod_'.$mod_name.'_page_settings` WHERE `section_id` = '.(int)$section_id.' ');
$fetch_page_settings = $query_page_settings->fetchRow(MYSQLI_ASSOC);

// Set raw html <'s and >'s to be replaced by friendly html code
$raw      = array('<', '>');
$friendly = array('&lt;', '&gt;');

// Hide page detail settings
$hide_setting = $view_detail_pages ? '' : 'display: none;';
$sHelpUrl = WB_URL.'/modules/'.$mod_name.'/help.php?page_id='.$page_id.'&section_id='.$section_id;
    $aAddon = json_encode([
        'AddonName' => $mod_name,
        'page_id' => $page_id,
        'section_id' => $section_id
    ]);
    $oModName = (object)$mod_name;
?>
<div id="AddonFolder" class="w3-hide"><?php echo basename(__DIR__);?></div>
    <script>
        if (!<?php echo $oModName->scalar;?>) {var <?php echo $oModName->scalar;?> = <?php echo $aAddon;?>};
        // Define an object with some properties
        var mod_<?php echo $mod_name; ?> = {
            mod_name: '<?php echo $mod_name; ?>',
            txt_dragdrop_message: '<?php echo $MOD_ONEFORALL[$mod_name]['TXT_DRAGDROP_MESSAGE']; ?>'
        };
    </script>

<form name="modify" action="<?php echo WB_URL; ?>/modules/<?php echo $mod_name; ?>/save_page_settings.php" method="post" style="margin: 0;">

    <input type="hidden" name="section_id" value="<?php echo $section_id; ?>" />
    <input type="hidden" name="page_id" value="<?php echo $page_id; ?>" />

    <h2><?php echo $MOD_ONEFORALL[$mod_name]['TXT_PAGE_SETTINGS']; ?></h2>
    <table id="mod_<?php echo $mod_name; ?>_page_settings_b">
      <tbody>
        <tr>
          <td><?php echo $MOD_ONEFORALL[$mod_name]['TXT_LAYOUT'].' '.$MOD_ONEFORALL[$mod_name]['TXT_SETTINGS']; ?>:</td>
          <td>
              <input id="help-started" class="btn btn-default" type="button" value="<?php echo $MENU['HELP']; ?>" data-url="<?php echo $sHelpUrl;?>" />
          </td>
          <td>&#160;</td>
        </tr>
        <tr>
            <td><?php echo $MOD_ONEFORALL[$mod_name]['TXT_OVERVIEW'].' ('.$TEXT['HEADER']; ?>):</td>
            <td colspan="2">
                <textarea name="header"><?php echo stripslashes($fetch_page_settings['header']); ?></textarea></td>
        </tr>
        <tr>
            <td><?php echo $MOD_ONEFORALL[$mod_name]['TXT_OVERVIEW'].' ('.$MOD_ONEFORALL[$mod_name]['TXT_ITEM'].'-'.$TEXT['LOOP']; ?>):</td>
            <td colspan="2">
                <textarea name="item_loop"><?php echo stripslashes($fetch_page_settings['item_loop']); ?></textarea></td>
        </tr>
        <tr>
            <td><?php echo $MOD_ONEFORALL[$mod_name]['TXT_OVERVIEW'].' ('.$TEXT['FOOTER']; ?>):</td>
            <td colspan="2">
                <textarea name="footer"><?php echo str_replace($raw, $friendly, stripslashes($fetch_page_settings['footer'])); ?></textarea></td>
        </tr>
        <tr style="<?php echo $hide_setting; ?>">
            <td><?php echo $MOD_ONEFORALL[$mod_name]['TXT_DETAIL'].' ('.$TEXT['HEADER']; ?>):</td>
            <td colspan="2">
                <textarea name="item_header"><?php echo str_replace($raw, $friendly, stripslashes($fetch_page_settings['item_header'])); ?></textarea>        </td>
        </tr>
        <tr style="<?php echo $hide_setting; ?>">
            <td><?php echo $MOD_ONEFORALL[$mod_name]['TXT_DETAIL'].' ('.$TEXT['FOOTER']; ?>):</td>
            <td colspan="2">
                <textarea name="item_footer"><?php echo str_replace($raw, $friendly, stripslashes($fetch_page_settings['item_footer'])); ?></textarea>        </td>
        </tr>
        <tr>
            <td><?php echo $MOD_ONEFORALL[$mod_name]['TXT_ITEMS_PER_PAGE']; ?>:</td>
            <td colspan="2">
                <input type="text" name="items_per_page" style="width: 35px" value="<?php echo $fetch_page_settings['items_per_page']; ?>" /> 0 = <?php echo $TEXT['UNLIMITED']; ?>        </td>
        </tr>
        <?php if (extension_loaded('gd') AND function_exists('imageCreateFromJpeg')) { /* Make's sure GD library is installed */ ?>
        <tr>
            <td><?php echo $MOD_ONEFORALL[$mod_name]['TXT_THUMBNAIL'].' '.$TEXT['SIZE']; ?>:</td>
            <td colspan="2">
                <select name="resize">
                <?php
                foreach (range($thumb_resize_smallest,$thumb_resize_largest,$thumb_resize_steps) as $key => $size) {
                    $selected = $size == $fetch_page_settings['resize'] ? ' selected="selected"' : '';
                    echo '<option value="'.$size.'"'.$selected.'>max. '.$size.'px</option>';
                }
                ?>
                </select>
            </td>
        </tr>
        <tr>
            <td>Lightbox2:</td>
            <td colspan="2">
              <input type="checkbox" name="lb2_overview" id="lb2_overview" value="overview" <?php if ($fetch_page_settings['lightbox2'] == 'overview' || $fetch_page_settings['lightbox2'] == 'all') { echo "checked='checked'"; } ?> />
              <label for="lb2_overview"><?php echo $MOD_ONEFORALL[$mod_name]['TXT_OVERVIEW']; ?></label> &nbsp;&nbsp;
              <span style="<?php echo $hide_setting; ?>">
                <input type="checkbox" name="lb2_detail" id="lb2_detail" value="detail" <?php if ($fetch_page_settings['lightbox2'] == 'detail' || $fetch_page_settings['lightbox2'] == 'all') { echo "checked='checked'"; } ?> />
                <label for="lb2_detail"><?php echo $MOD_ONEFORALL[$mod_name]['TXT_DETAIL']; ?></label>
              </span>
              </td>
        </tr>
        <tr>
            <td><?php echo $MOD_ONEFORALL[$mod_name]['TXT_BACKEND_ITEM_PAGE']; ?>:</td>
            <td colspan="2">
              <input type="checkbox" name="img_section" id="img_section" value="1" <?php if ($fetch_page_settings['img_section'] == '1') { echo 'checked="checked"'; } ?> />
              <label for="img_section"><?php echo $MOD_ONEFORALL[$mod_name]['TXT_HIDE_IMG_SECTION']; ?></label> &nbsp;&nbsp;
            </td>
        </tr>
        <?php } ?>
      </tbody>
    </table>

    <?php
    // OneForAll page list
    $query_pages = 'SELECT `p`.`page_id`, '
                . '`p`.`page_title`, '
                . '`p`.`visibility`, '
                . '`p`.`admin_groups`, '
                . '`p`.`admin_users`, '
                . '`p`.`viewing_groups`, '
                . '`p`.`viewing_users`, '
                . '`s`.`page_id`, '
                . '`s`.`section_id`, '
                . '`s`.`title` '
                . 'FROM `'.TABLE_PREFIX.'pages` `p` '
                . 'INNER JOIN `'.TABLE_PREFIX.'sections` `s` '
                . 'ON `p`.`page_id` = `s`.`page_id` '
                . 'WHERE `s`.`module` = \''.$mod_name.'\' '
                . 'AND `p`.`visibility` != \'deleted\' '
                . 'ORDER BY `p`.`level`, `p`.`position` ASC';
    $get_pages = $database->query($query_pages);


    // Generate sections select
    if ($get_pages->numRows() > 0) {
        $sections_select = '';
        while ($page = $get_pages->fetchRow(MYSQLI_ASSOC)) {
            $page = array_map('stripslashes', $page);
            // Only display if visible
            if ($admin->page_is_visible($page) == false)
                continue;
            // Get user perms
            $admin_groups = explode(',', str_replace('_', '', $page['admin_groups']));
            $admin_users = explode(',', str_replace('_', '', $page['admin_users']));
            // Check user perms
            $in_group = FALSE;
            foreach ($admin->get_groups_id() as $cur_gid) {
                if (in_array($cur_gid, $admin_groups)) {
                    $in_group = TRUE;
                }
            }
            if (($in_group) OR is_numeric(array_search($admin->get_user_id(), $admin_users))) {
                $can_modify = true;
            } else {
                $can_modify = false;
            }
            // Options
            $sections_select .= "<option value='{$page['section_id']}'";
            if (isset($fetch_item['new_section_id']) && $fetch_item['new_section_id'] == $page['section_id']) {
                $sections_select .= " selected='selected'";
            }
            elseif ($section_id == $page['section_id']) {
                $sections_select .= " selected='selected'";
            }
            $sections_select .= $can_modify == false ? " disabled='disabled' style='color: #aaa;'" : '';
            $sections_select .= ">{$page['page_id']} - {$page['page_title']} - {$page['title']}</option>\n";
        }
    }

    // Save page settings   ?>
    <table class="mod_ofa_modify_item ofa_bottom mod_<?php echo $mod_name; ?>_submit_b">
      <tbody>
        <tr>
            <td><input type="radio" name="modify" id="modify_current" value="current" checked="checked" /></td>
            <td colspan="2"><label for="modify_current"><em><?php echo $MOD_ONEFORALL[$mod_name]['TXT_MODIFY_THIS']; ?></em></label></td>
        </tr>
        <tr>
            <td><input type="radio" name="modify" id="modify_all" value="all" /></td>
            <td colspan="2"><label for="modify_all"><em><?php echo $MOD_ONEFORALL[$mod_name]['TXT_MODIFY_ALL']; ?></em></label></td>
        </tr>

        <tr>
            <td><input type="radio" name="modify" id="modify_multiple" value="multiple" /></td>
            <td><label for="modify_multiple"><em><?php echo $MOD_ONEFORALL[$mod_name]['TXT_MODIFY_MULTIPLE']; ?></em></label></td>
            <td style="width: 25%;" >
              <select name="modify_sections[]" multiple="multiple">
                <?php echo $sections_select; ?>
              </select>
            </td >
            <td style="width: 1.5%;;"><span>&#160;</span></td>
        </tr>
        <tr>
            <td colspan="4">&nbsp;</td>
        </tr>
      </tbody>
    </table>

    <table class="mod_ofa_modify_item">
        <tr>
            <td style="height: 30px; float: left;">
              <button class="btn btn-default " name="save" type="submit" value="1" style="min-width: 8.525em; margin: 5px 0 0 15px;" ><?php echo $TEXT['SAVE']; ?></button>
              <button class="btn btn-default " name="save_and_return" type="submit" value="1" style="margin: 5px 0 0 15px;" ><?php echo $MOD_ONEFORALL[$mod_name]['TXT_SAVE_AND_BACK_TO_LISTING']; ?></button>
            </td>
            <td style="height: 30px; float: right;">
              <button class="btn btn-default " type="button" onclick="window.location='<?php echo ADMIN_URL; ?>/pages/modify.php?page_id=<?php echo $page_id; ?>';" style="min-width: 8.525em; margin: 5px 15px 0 0;" ><?php echo $TEXT['CLOSE']; ?></button>
            </td>
        </tr>
    </table>
</form>

<?php
    $jsPanelPath = WB_URL.'/modules/'.$mod_name.'/vendor/';
    $JsPanelJs   = $jsPanelPath.'/plugins/default/jspanel/4.2.1/dist/jspanel-org.js';
    $JsPanelCss  = $jsPanelPath.'/plugins/default/jspanel/4.2.1/dist/jspanel.css';
    if (version_compare(VERSION, '2.12.1', '<')) {
?>
<script>
      var JsPanelCss = "<?php echo $JsPanelCss; ?>";
      if (typeof LoadOnFly!=='function' || typeof LoadOnFly==='undefined' || !LoadOnFly){
          $.insert(JsPanelCss);
      } else {
          LoadOnFly('head', JsPanelCss);
      }
</script>
<script src="<?php echo $JsPanelJs; ?>"></script>
<?php
    }
// Print admin footer
    $admin->print_footer();

