<?php
/*
  Module developed for the Open Source Content Management System WebsiteBaker (http://websitebaker.org)
  Copyright (C) 2017, Christoph Marti

  LICENCE TERMS:
  This module is free software. You can redistribute it and/or modify it
  under the terms of the GNU General Public License  - version 2 or later,
  as published by the Free Software Foundation: http://www.gnu.org/licenses/gpl.html.

  DISCLAIMER:
  This module is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.
*/

if (!\defined('SYSTEM_RUN')) {header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 File not found'; flush(); exit;}

// Resize PNG image
    function resizePNG($sSource, $sDestination, $width, $height) {
        // Check if GD is installed
        $mRetVal = null;
            // Check if GD is installed
        if (extension_loaded('gd') && function_exists('imagecreatefrompng')) {
            $aOptions = array(
                'resizeUp'              => false,
                'jpegQuality'           => 100,
                'correctPermissions'    => false,
                'preserveAlpha'         => true,
                'alphaMaskColor'        => array (255, 255, 255),
                'preserveTransparency'  => true,
                'transparencyMaskColor' => array (0, 0, 0),
                'interlace'             => null
            );
//            $aExif = (function_exists('exif_read_data') ? @exif_read_data($sSource) : []);
            if (!class_exists('\bin\media\GD')){
                if (!class_exists('')){require __DIR__.'/vendor/plugins/media/GD.php';}
                $thumb = new GD($sSource,$aOptions);
            } else {
                $thumb = new \bin\media\GD($sSource,$aOptions);
            }
            $thumb->resize($width, $height); // adaptiveResize
            $mRetVal = $thumb->save($sDestination);
            unset($thumb);
        }
        return $mRetVal;

    }


// Resize JPEG image
    function resizeJPEG($sSource, $sDestination, $width, $height, $iQuality = 75) {
        $mRetVal = null;
        if (extension_loaded('gd') && function_exists('imagecreatefromjpeg')) {
            $aOptions = array(
                'resizeUp'              => false,
                'jpegQuality'           => $iQuality,
                'correctPermissions'    => false,
                'preserveAlpha'         => true,
                'alphaMaskColor'        => array (255, 255, 255),
                'preserveTransparency'  => true,
                'transparencyMaskColor' => array (0, 0, 0),
                'interlace'             => null
            );
            $aExif = (function_exists('exif_read_data') ? @exif_read_data($sSource) : []);
            if (!class_exists('\bin\media\GD')){
                if (!class_exists('')){require __DIR__.'/vendor/plugins/media/GD.php';}
                $thumb = new GD($sSource,$aOptions);
            } else {
                $thumb = new \bin\media\GD($sSource,$aOptions);
            }
            $thumb->resize($width, $height); // adaptiveResize
            $mRetVal = $thumb->save($sDestination);
            unset($thumb);
        }
        return $mRetVal;
/*
    if ($type == 1) {
        $thumb->adaptiveResize(20,20);
//        $thumb->resize(30,30);
//        $thumb->cropFromCenter(80,50);
//         $thumb->resizePercent(40);
    } else {
//         $thumb->resizePercent(25);
//        $thumb->cropFromCenter(80,50);
    }
    $thumb->show();
*/
    }

