<?php

/*
  Module developed for the Open Source Content Management System WebsiteBaker (http://websitebaker.org)
  Copyright (C) 2017, Christoph Marti

  LICENCE TERMS:
  This module is free software. You can redistribute it and/or modify it
  under the terms of the GNU General Public License - version 2 or later,
  as published by the Free Software Foundation: http://www.gnu.org/licenses/gpl.html.

  DISCLAIMER:
  This module is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.
*/


if (!defined('SYSTEM_RUN')) {require( (dirname(dirname((__DIR__)))).'/config.php');}

// Include WB admin wrapper script
$update_when_modified = true; // Tells script to update when this page was last updated
$print_info_banner = true;

require(WB_PATH.'/modules/admin.php');

// Include path
$inc_path = str_replace('\\','/',__DIR__);
// Get module name
//    require($inc_path.'/info.php');
    require($inc_path.'/convert.php');

// Look for language file
if (is_readable(__DIR__.'/languages/EN.php')) {require(__DIR__.'/languages/EN.php');}
if (is_readable(__DIR__.'/languages/'.DEFAULT_LANGUAGE.'.php')) {require(__DIR__.'/languages/'.DEFAULT_LANGUAGE.'.php');}
if (is_readable(__DIR__.'/languages/'.LANGUAGE.'.php')) {require(__DIR__.'/languages/'.LANGUAGE.'.php');}

// Get field default values
require($inc_path.'/add_field.php');

// Save $sync_type_template in the session
$_SESSION[$mod_name]['sync_type_template'] = isset($_POST['sync_type_template']) ? ' checked="checked"' : '';
// Sanitize post var
//$new_fields = is_numeric($_POST['new_fields']) ? $_POST['new_fields'] : 0;
//$save       = isset($_POST['save'])            ? 1 : 0;
//$add_fields = isset($_POST['add_fields'])      ? 1 : 0;
$new_fields = $oRequest->getParam('new_fields', FILTER_VALIDATE_INT);
$add_fields = $oRequest->getParam('add_fields', FILTER_VALIDATE_BOOLEAN);
$sSave      = $oRequest->getParam('save', FILTER_VALIDATE_BOOLEAN);
$sSaveBack  = $oRequest->getParam('save_back', FILTER_VALIDATE_BOOLEAN);

// Update fields
if (!empty($_POST['fields'])) {
    foreach ($_POST['fields'] as $field_id => $fields) {
        // Add slashes and remove any tags
        $field_id = $admin->add_slashes(strip_tags($field_id));
        $type     = $admin->add_slashes(strip_tags($fields['type']));
        $extra    = $admin->add_slashes(strip_tags($fields['extra']));
        $name     = $admin->add_slashes(strip_tags($fields['name']));
        $label    = $admin->add_slashes(strip_tags($fields['label']));
        $template = $admin->add_slashes($fields['template']);

        // First delete field if requested
        if ($type == 'delete') {
            $database->query('DELETE FROM `'.TABLE_PREFIX.'mod_'.$mod_name.'_fields` WHERE `field_id` = '.(int)$field_id.' ');
            $database->query('DELETE FROM `'.TABLE_PREFIX.'mod_'.$mod_name.'_item_fields` WHERE `field_id` = '.(int)$field_id.' ');
            // Field has been deleted, no need to do more
            continue;
        }

        // Just one group field allowed
        // Get group field id to check if there is already existing a group field
        $first_group_field_id = $database->get_one('SELECT `field_id` FROM `'.TABLE_PREFIX.'mod_'.$mod_name.'_fields` WHERE `type` = \'group\' ');
        // Error message and continue
        if ($type == 'group' && $first_group_field_id != null && $field_id != $first_group_field_id) {
            $errors[] = sprintf($MOD_ONEFORALL[$mod_name]['ERR_ONLY_ONE_GROUP_FIELD'], htmlspecialchars($name));
            continue;
        }

        // Check if field name is blank
        if (empty($name) && !isset($error_blank_field)) {
            // Set flag to show error message only once
            $error_blank_field = true;
            $errors[]  = $MOD_ONEFORALL[$mod_name]['ERR_BLANK_FIELD_NAME'];
            continue;
        }

        // Prevent conflicts between customized field names and general placeholders
        $reserved_names = array('BACK', 'DATE', 'DISPLAY_NAME', 'DISPLAY_PREVIOUS_NEXT_LINKS', 'USER_EMAIL', 'FIELD_NAME', 'IMAGE', 'IMAGES', 'ITEM_ID', 'LINK', 'NEXT', 'NEXT_LINK', 'NEXT_PAGE_LINK', 'OF', 'OUT_OF', 'PAGE_TITLE', 'PREVIOUS', 'PREVIOUS_LINK', 'PREVIOUS_PAGE_LINK', 'TEXT_OF', 'TEXT_OUT_OF', 'TEXT_READ_MORE', 'TXT_BACK', 'TXT_DESCRIPTION', 'TXT_ITEM', 'THUMB', 'THUMBS', 'TIME', 'TITLE', 'USERNAME', 'USER_ID');
        if (in_array(strtoupper($name), $reserved_names)) {
            $errors[] = sprintf($MOD_ONEFORALL[$mod_name]['ERR_CONFLICT_WITH_RESERVED_NAME'], htmlspecialchars($name));
            continue;
        }

        // Check field name for invalid chars
        if (!preg_match('#^[a-zA-Z0-9._-]*$#', $name)) {
            $errors[] = sprintf($MOD_ONEFORALL[$mod_name]['ERR_INVALID_FIELD_NAME'], htmlspecialchars($name));
            continue;
        }

        // If template is blank use the default one
        if (empty($template)) {
            $template = $field_template[$type];
        }

        // If field type oneforall_link check the module name and convert it if needed
        if ($type == 'oneforall_link') {
            $extra = trim($extra);
            $extra = str_replace(' ', '_', strtolower($extra));
            $extra = empty($extra) || !preg_match('/^[a-z0-9_-]{3,20}$/', $extra) ? 'oneforall' : $extra;
        }

        // If no error occurred, update existing field
        if (is_numeric($field_id)) {
            $update_string = '`type` = \''.$type.'\', `extra` = \''.$extra.'\', `name` = \''.$name.'\', `label` = \''.$label.'\', `template` = \''.$template.'\' ';
            #$database->query("UPDATE `".TABLE_PREFIX."mod_".$mod_name."_fields` SET $update_string WHERE field_id = '$field_id'");
            $sUpdateFields =  'UPDATE `'.TABLE_PREFIX.'mod_'.$mod_name.'_fields` SET '
                           .  ' '.$update_string.' '
                           .  'WHERE `field_id` = '.$field_id.' ';
            $database->query($sUpdateFields);
            if ($database->is_error()) {
                $errors[] = $database->get_error();
                $errors[] = "Line 122";
            }
        }

        // Check if field name is unique
        if ($database->is_error()) {
            if (false !== strpos($database->get_error(), 'Duplicate entry')) {
                if (!empty($name)) {
                    $errors[] = sprintf($MOD_ONEFORALL[$mod_name]['ERR_FIELD_NAME_EXISTS'], htmlspecialchars($name));

                }
            }
            // ...or get any other db error
            else {
                $errors[] = $database->get_error();
            }
        }
    }
}
    // update section_id
    $sql = 'UPDATE `'.TABLE_PREFIX.'mod_'.$mod_name.'_fields` SET '
        . '`section_id` ='.(int)$section_id.' '
//        . '`position` = 0 '
        . 'WHERE `section_id` = '.($section_id ?: 0);
    if (!$database->query($sql)){echo $database->get_error();}
/*
    $order = new \order(TABLE_PREFIX.'mod_'.$mod_name.'_fields', 'position', 'field_id', 'section_id');
    $order->clean($section_id);
    unset($order);
*/
// Insert new fields
if ($add_fields && $new_fields > 0) {
    for ($i = 0; $i < $new_fields; $i++) {
        $name     = $MOD_ONEFORALL[$mod_name]['TXT_NEW_FIELD_NAME'].'_';
        $template = $field_template['text'];

        // Insert new fields into fields table
        #$database->query('INSERT INTO `'.TABLE_PREFIX.'mod_'.$mod_name.'_fields` (`type`, `template`) VALUES (\'text\', \''.$template.'\')');
        $Sql =  'INSERT INTO `'.TABLE_PREFIX.'mod_'.$mod_name.'_fields` SET '
                .  '`section_id`= '.(int)$section_id.', '
                .  '`type`= \'text\', '
                .  '`extra`= \'\', '
                .  '`template`= \''.$template.'\' ';
        $database->query($Sql);
        #echo $Sql."<br>";
        if ($database->is_error()) {
            $errors[] = $database->get_error();
            $errors[] = "Line 157";
        }
        $field_id = $database->getLastInsertId();
        $database->query('UPDATE `'.TABLE_PREFIX.'mod_'.$mod_name.'_fields` SET `name` = CONCAT(\''.$name.'\', '.$field_id.') WHERE `field_id` = '.(int)$field_id.' ');
        if ($database->is_error()) {
            $errors[] = $database->get_error();
            $errors[] = "Line 163";
        }

        // Insert the new fields into the item_fields table as well
        $sSql = 'INSERT INTO `'.TABLE_PREFIX.'mod_'.$mod_name.'_item_fields` (`item_id`, `field_id`,`value`) '
              . 'SELECT `item_id`, '.$field_id.', \'\' '
              . 'FROM `'.TABLE_PREFIX.'mod_'.$mod_name.'_items`';
        $database->query($sSql);

        if ($database->is_error()) {
            $errors[] = $database->get_error();
            $errors[] = "Line 174";
        }
    }
}


// Check if there has been any error, otherwise say successful
if (!empty($errors)) {
    $sBackLink = WB_URL.'/modules/'.$mod_name.'/modify_fields.php?page_id='.$page_id.'&section_id='.$section_id.'&new_fields='.$new_fields;
    $sBackLink = ADMIN_URL.'/pages/modify.php?page_id='.$page_id;
    $admin->print_error(implode('<br />', $errors), $sBackLink);
}
else {
    // Inserted new fields
    if ($add_fields) {
        $sBackLink = WB_URL.'/modules/'.$mod_name.'/modify_fields.php?page_id='.$page_id.'&section_id='.$section_id;
        $admin->print_success($TEXT['ADD_SUCCESS'], $sBackLink);
    } elseif ($sSave) {
    // Updated fields
        $sBackLink = WB_URL.'/modules/'.$mod_name.'/modify_fields.php?page_id='.$page_id.'&section_id='.$section_id;
        $admin->print_success($TEXT['UPDATE_SUCCESS'], $sBackLink);
    }else {
    $sBackLink = ADMIN_URL.'/pages/modify.php?page_id='.$page_id;
        $admin->print_success($TEXT['UPDATE_SUCCESS'], $sBackLink);
    }
}

// Print admin footer
$admin->print_footer();

